﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

/**
 * 此程序作者：https://home.cnblogs.com/u/shenyuanfeng/
 * 仅供学习参考使用！
 * 2019年10月31日
 * */

namespace Test
{
    public partial class RectangleIntersect : Form
    {
        private Random random;
        private Rectangle rectangle1;
        private Rectangle rectangle2;

        public RectangleIntersect()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        /** 生成两个随机矩形 */
        private void randomRectangle()
        {
            Graphics graphics = this.CreateGraphics();
            graphics.Clear(BackColor);

            Pen pen1 = new Pen(Color.Red, 2);
            Pen pen2 = new Pen(Color.Blue, 2);

            random = new Random();
            rectangle1 = new Rectangle(random.Next(0,150),random.Next(0,100),random.Next(1,149),random.Next(1,100)); //生成随机矩形1
            rectangle2 = new Rectangle(random.Next(0, 150), random.Next(0, 100), random.Next(1, 149), random.Next(1, 100)); //生成随机矩形2

            graphics.DrawRectangle(pen1, rectangle1);
            graphics.DrawRectangle(pen2, rectangle2);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            randomRectangle();

            int flag = 0; //设置标记值，默认为重叠
            if (rectangle1.X > rectangle2.X + rectangle2.Width || rectangle1.Y > rectangle2.Y + rectangle2.Height) flag++; //初始点在3，6，7，8，9区域
            else if (rectangle1.X + rectangle1.Width < rectangle2.X || rectangle1.Y + rectangle1.Height < rectangle2.Y) flag++; //初始点在1区域
            /**
             * 下方注掉的代码用于判断矩形内含，取消注释则内含显示不重叠，即可用于判断是否相交
             */
            else if (rectangle1.X > rectangle2.X && rectangle1.Y > rectangle2.Y && rectangle1.X + rectangle1.Width < rectangle2.X + rectangle2.Width && rectangle1.Y + rectangle1.Height < rectangle2.Y + rectangle2.Height) flag++; //初始点在5区域

            if (flag == 0) textBox1.Text = "重叠";
            else textBox1.Text = "不重叠";

            /**
            * 区域说明：以第5块区域为其中一个矩形初始位置，将其余上下左右等如此分割成9份进行判断
            * 
            *   1  |  2  |  3
            *  ----------------
            *   4  |  5  |  6
            *  ----------------
            *   7  |  8  |  9
            * 
            **/
        }

        private void button2_Click(object sender, EventArgs e)
        {
            randomRectangle();

            /**
             * 通过C#的 IntersectsWith 方法可直接判断是否重叠
             * 
             */

            if (rectangle1.IntersectsWith(rectangle2)) textBox1.Text = "重叠";
            else textBox1.Text = "不重叠";
        }
    }
}

